#!/usr/bin/env python3
""" Statistical Language processing, Assignment 1
    See <https://snlp2021.github.io/a1/> for detailed instructions.

    <Please insert your name and the honor code here.>
"""

def get_authors(bibdata):
    """ Get authors in bibdata sorted by number of first-authored publications.

    Parameters:
    bibdata: bibliography data. You can pass the name of the file and
             parse it here, but you can avoid re-parsing it if you
             read the file in advance.

    Returns: A sequence of authors.
    """
    ## Exercise 1.1

def get_author_info(authors, numauthors=50, sleep=2):
    """ Get information on authors from Wikidata.
    Parameters:
    authors: A sequence of authors
    numauthors: The number of authors to obtain full information
    sleep: Amount of time to sleep between Wikidata queries

    Returns: A dictionary with author name as key
             and a tuple (Wikidata_id, birth, gender, nationality)
             as data
    """
    ## Exercise 1.2

def save_corpus(authors, bibdata, outputfile):
    """ Write the corpus with meta data to output file.

    Parameters:
    authors: A dictionary of authors with meta data as returned by
             get_author_info()
    bibdata: bibliography data. You can pass the name of the file and
             parse it here, but you can avoid re-parsing it if you
             read the file in advance.
    outputfile: The name of the output file.
    """
    ## Exercise 1.3

if __name__ == "__main__":
    #
    # Your testing code can go here (normally you should use pytest
    # but not required for this course). 
    # You may also want to read and process bibliography data here,
    # to avoid doing it twice in get_authors() and save_corpus().
    #
